#include <IBusBM.h>
#include "Joystick.h"

// Create Joystick
Joystick_ Joystick;

IBusBM IBus; // IBus object

void setup()
{
  Serial.begin(115200);
  IBus.begin(Serial1);
  //   Set Range Values
  Joystick.setXAxisRange(-127, 127);
  Joystick.setYAxisRange(-127, 127);
  Joystick.setZAxisRange(-127, 127);
  Joystick.setRxAxisRange(0, 255);
  Joystick.setRyAxisRange(0, 255);
  Joystick.setRzAxisRange(0, 255);
  Joystick.setThrottleRange(0, 255);
  Joystick.setRudderRange(0, 255);
  Joystick.begin(false);
}

int16_t C[10];
int16_t Cnew[10];
int i;

uint32_t tectime = 0;
void loop()
{
  //delay(20); убираем задержку, но оставляем периодичность/частоту обработки
  uint32_t millis_ = millis();
  if (tectime <= millis_)
  {
    tectime = millis_ + 20;
    for (i = 0; i < 8; i++)
    {
      C[i] = IBus.readChannel(i) - 1000;
      switch (i)      {
        case 0:
          Joystick.setXAxis(((C[i] - 500) * 25) / 100);
          break;
        case 1:
          Joystick.setYAxis(((C[i] - 500) * 25)  / 100);
          break;
        case 2:
          Joystick.setZAxis(((C[i] - 500) * 25)  / 100);
          break;
        case 3:
          Joystick.setRxAxis((C[i] * 25) / 100);
          break;
        // двлее кнопки
        case 4:
          Joystick.setRyAxis((C[i] * 25) / 100);
          break;
        case 5:
          Joystick.setRzAxis((C[i] * 25) / 100);
          break;
        case 6:
          Joystick.setThrottle((C[i] * 25) / 100);
          break;
        case 7:
          Joystick.setRudder((C[i] * 25) / 100);
          break;
      }
    }
    Joystick.sendState();
  }
}
